!
      program ex2
!
      use HDF5
      implicit none
!
      character(len=20), parameter :: file_name="RUN/my_2nd_file.h5"
      integer(hid_t) :: file_id       !! file identifier
      integer(hid_t) :: group_id      !! group identifier
      integer        :: hdferr

!
      write(6,*) "writing h5 file ", file_name, "with group"
!
! open the fortran interface for hdf5   
      call h5open_f(hdferr);

! create the file using default properties.
      call h5fcreate_f(file_name, H5F_ACC_TRUNC_F, file_id, hdferr, &
                       H5P_DEFAULT_F, H5P_DEFAULT_F)

!create a group named "/MyGroup" in the file. */
      call h5gcreate_f(file_id, "MyGroup", group_id, hdferr, &
                       OBJECT_NAMELEN_DEFAULT_F, H5P_DEFAULT_F, &
                       H5P_DEFAULT_F, H5P_DEFAULT_F)

! close the group
      call h5gclose_f(group_id, hdferr)

! close the file
      call h5fclose_f(file_id, hdferr)

! close the inteface
      call h5close_f(hdferr)

      write(6,*) ".... done"

      end program ex2
