#include <hdf5.h>
int main() {
        
char H5FILE_NAME[128];
hid_t file_id;              /* file identifier */
hid_t group_id;             /* group identifier */
hid_t group1_id, group2_id; /* sub-group identifier */
hid_t dataset_id;           /* dataset identifier */
hid_t dataspace_id;         /* dataspace identifier */
hid_t dcpl;                 /* dataset creation property */
hsize_t dims[2]={4,6};
herr_t status;

/* filename */
sprintf(H5FILE_NAME,"RUN/%s.h5","my_fourth_file");
printf("creating h5 file: %s with group & dataset...",H5FILE_NAME);

/* Create a new file using default properties. */
file_id = H5Fcreate (H5FILE_NAME,H5F_ACC_TRUNC,H5P_DEFAULT,H5P_DEFAULT);

/* Create a group named "/MyGroup" in the file. */
group_id = H5Gcreate(file_id, "/MyGroup",H5P_DEFAULT,H5P_DEFAULT,H5P_DEFAULT);

/* Create sub-group "Group_A" in group "MyGroup" using absolute name. */
group1_id = H5Gcreate(file_id, "/MyGroup/Group_A", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT); 

/* Create sub group "Group_B" in group "MyGroup" using relative name. */
group2_id = H5Gcreate(group_id, "Group_B", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT); 

/* create simple dataspace */
dataspace_id = H5Screate_simple (2, dims, NULL);

/* create dataset creation property list */
dcpl = H5Pcreate (H5P_DATASET_CREATE); 

/* create datset */
dataset_id = H5Dcreate(file_id,"dset",H5T_STD_I32BE, dataspace_id, H5P_DEFAULT, dcpl, H5P_DEFAULT);

/* Close dataset et al... */
status = H5Dclose (dataset_id); 
status = H5Sclose (dataspace_id);
status = H5Pclose (dcpl); 

/* Close all the groups. */
status = H5Gclose(group_id);
status = H5Gclose(group1_id); 
status = H5Gclose(group2_id); 

/* Terminate access to the file. */
status = H5Fclose (file_id);
printf("...done\n");
}
