#include <hdf5.h>
#include <assert.h>
int main() {
        
char H5FILE_NAME[128];
hid_t file_id;              /* file identifier */
hid_t group_id;             /* group identifier */
hid_t group1_id;            /* sub-group identifier */
hid_t dataset_id;           /* dataset identifier */
hid_t dataspace_id;         /* dataspace identifier */
hid_t strspace_id;         /* dataspace identifier */
hid_t str_type; 
hsize_t dims[1]={7};
hsize_t index[1];

herr_t status;
const char* days[] = {"Mon","Tue","Wed","Thu","Fri","Sat","Sun"};
int i;

/* filename */
sprintf(H5FILE_NAME,"RUN/%s.h5","my_fifth_file");
printf("creating h5 file: %s with group & dataset...",H5FILE_NAME);

/* Create a new file using default properties. */
file_id = H5Fcreate (H5FILE_NAME,H5F_ACC_TRUNC,H5P_DEFAULT,H5P_DEFAULT);

/* Create a group named "/MyGroup" in the file. */
group_id = H5Gcreate(file_id, "/Week",H5P_DEFAULT,H5P_DEFAULT,H5P_DEFAULT);

/* Create sub-group "Group_A" in group "MyGroup" using absolute name. */
group1_id = H5Gcreate(file_id, "/Week/Days", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT); 

/* create simple dataspace */
dataspace_id = H5Screate_simple (1, dims, NULL);
assert(dataspace_id != -1);
// strspace_id = H5Screate(H5S_SCALAR);
strspace_id = H5Screate(H5S_SCALAR); 
assert(strspace_id != -1);

/* create the fixed lenght string datatype */
str_type = H5Tcopy(H5T_C_S1);
assert(str_type != -1);
status = H5Tset_size(str_type, 3);
assert(status != -1);

/* create datset */
dataset_id = H5Dcreate(file_id, "dset", str_type, dataspace_id, H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT);
assert(dataset_id != -1);

for (i=0; i<7; ++i) {
  /* select a string from the array */
  index[0]=i;
  status = H5Sselect_elements(dataspace_id, H5S_SELECT_SET, 1, index);
  assert(status != -1);

  /* write dataset */ 
  status = H5Dwrite(dataset_id, str_type, strspace_id, dataspace_id, H5P_DEFAULT, days[i]); 
  assert(status != -1);
}

/* Close dataset et al... */
status = H5Tclose (str_type);
status = H5Dclose (dataset_id); 
status = H5Sclose (dataspace_id);
status = H5Sclose (strspace_id);

/* Close all the groups. */
status = H5Gclose(group_id);
status = H5Gclose(group1_id); 

/* Terminate access to the file. */
status = H5Fclose (file_id);
printf("...done\n");
}
